/*****************************************
* data.c - Data Manipulation Functions
*
* CVS $Id: data.c,v 1.8 2000/12/15 03:43:33 wcampbel Exp $
*****************************************/

#include "split.h"

void InitTables()
{
	register int i;

        for (i=0; i<MAXSERVER; i++) {
                server_table[i] = NULL;
        }
        map_head = NewServer(me.name, NULL);
        for (i=0; i<MAXSERVER; i++) {
                split_table[i] = NULL;
        }
}

Server* NewServer(char* name, char* uplink)
{
	int i,j;
	Server* up = FindServer(uplink);
	Server* s = malloc(sizeof(Server));
	s->name = name;
	s->uplink = up;
	s->numleaf = 0;
	for (i=0; i<MAXSERVER; i++)
	{
		s->leaflist[i] = NULL;
	}
	if (up)
	{
		up->numleaf++;
		for(j=0; j<MAXSERVER; j++)
		{
			if (!up->leaflist[j]) {
				up->leaflist[j] = s;
				break;
			}
		}
	}
	for (i=0; i<MAXSERVER; i++)
	{
		if (!server_table[i]) {
			server_table[i] = s;
			break;
		}
	}
	return s;
}

void DelServer(char* name)
{
	int i;
	int j;
	Server* s = NULL;
	if (name) {
		for (j=0; j<MAXSERVER; j++) {
			if (server_table[j]) {
				if (!strcasecmp(name, server_table[j]->name)) {
					s = server_table[j];
					server_table[j] = NULL;
				}
			}
		}
		if (s) {
			s->uplink->numleaf--;
			for (i=0; i<MAXSERVER; i++) {
				if (s->uplink->leaflist[i]) {
					if (!strcasecmp(name, 
					    s->uplink->leaflist[i]->name)) {
						s->uplink->leaflist[i] = NULL;
					}
				}
			}
			free(s);
		}
	}
}

Server* FindServer(char* name)
{
	int i;
	if (name) {
		for (i=0; i<MAXSERVER; i++)
		{
			if (server_table[i]) {
				if (!strcasecmp(server_table[i]->name, name)) {
					return server_table[i];
				}
			}
		}
	}
	return NULL;
}

void NewSplit(char * name)
{
	Server* s = malloc(sizeof(Server));
	int i;
	s->name = name;
	s->ts = time(NULL);
	/* None of the other variables are used here */
	for (i=0; i<MAXSERVER; i++) {
		if (!split_table[i]) {
			split_table[i] = s;
			break;
		}
	}
}

void DelSplit(char * name)
{
	Server* s = NULL;
	int i;
	for (i=0; i<MAXSERVER; i++) {
		if (split_table[i]) {
			if (!strcasecmp(split_table[i]->name, name)) {
				s = split_table[i];
				split_table[i] = NULL;
				break;
			}
		}
	}
	if (s) {
		free(s);
	}
}

Server* FindSplit(char* name)
{
        int i;
        if (name) {
                for (i=0; i<MAXSERVER; i++)
                {
                        if (split_table[i]) {
                                if (!strcasecmp(split_table[i]->name, name)) {
                                        return split_table[i];
                                }
                        }
                }
        }
        return NULL;
}
