/*****************************************
* irc.c - IRC related subroutines
*
* CVS $Id: irc.c,v 1.63 2000/12/15 03:52:58 wcampbel Exp $
*****************************************/

#include "split.h"

void Register()
{
#ifdef IRCD_HYBRID
        sts("PASS %s :TS", me.pass);
        sts("SERVER %s 1 :%s", me.name, me.desc);
	sts("SVINFO 3 1 0 :%ld", time(NULL));
#endif
#ifdef IRCD_DAL
        sts("PASS %s", me.pass);
        sts("SERVER %s 1 :%s", me.name, me.desc);
#endif
#ifdef IRCD_HYB6
	sts("PASS %s :TS", me.pass);
	sts("CAPAB :QS");
	sts("SERVER %s 1 :%s", me.name, me.desc);
	sts("SVINFO 3 1 0 :%ld", time(NULL));
#endif
	notice = time(NULL) + me.delay;
	is_delayed = 1;
}

void InitSplitServ()
{
#ifdef IRCD_HYBRID
	sts("NICK %s 1 1 + %s %s %s :%s", SplitServ.nick,
                SplitServ.user, SplitServ.host, me.name, me.desc);
	sts(":%s SJOIN %ld %s + :%s", me.name, time(NULL), me.join_chan,
		SplitServ.nick);
#endif
#ifdef IRCD_HYB6
        sts("NICK %s 1 1 + %s %s %s :%s", SplitServ.nick,
                SplitServ.user, SplitServ.host, me.name, me.desc);
        sts(":%s SJOIN %ld %s + :%s", me.name, time(NULL), me.join_chan,
                SplitServ.nick);
#endif
#ifdef IRCD_DAL
        sts("NICK %s 1 1 %s %s %s 0 :%s", SplitServ.nick,
                SplitServ.user, SplitServ.host, me.name, me.desc);
	sts(":%s JOIN %s", SplitServ.nick, me.join_chan);
#endif
}

void Parse(char * buf)
{
        char *origin, *cmd, *coreLine;
        int cmdptr = 0;

        strip(buf);

        if (!(*buf))
                return;

        coreLine = strdup(buf);

#ifdef DEBUG
        log("R: %s", buf);
#endif
        origin = strtok(buf, " ");
        if (*origin == ':')
                cmdptr = 1;
        cmd = strtok(NULL, " ");

        if (cmdptr) {
                origin++;
		if (!strcasecmp(cmd, "SERVER")) {
			char *o, *c;
			Server * s;
			char* td;
			time_t now = time(NULL);
			cmd = strtok(NULL, " ");
			o = strdup(origin);
			c = strdup(cmd);
			s = FindSplit(c);
			if (s) {
				td = timediff(now - s->ts);
				log("End of Split: %s to %s: %s", c, o, 
					td);
				privmsg(me.join_chan, 
					"END OF SPLIT: %s to %s: %s",
					c, o, td);
				free(td);
			} else {
				if (!is_delayed) {
					log("New Server: %s to %s", c, o);
					privmsg(me.join_chan,
					    "CONNECT: %s to %s", c, o);
				}
			}
			NewServer(c, o);
			DelSplit(c);
                } else if (!strcasecmp(cmd, "VERSION")) {
                        sts(":%s 351 %s %s :%s", me.name, origin, me.name,
				me.version);
		} else if (!strcasecmp(cmd, "INVITE")) {
			char * cmd = strtok(NULL, " ");
			cmd = strtok(NULL, " ");
			cmd++;
			if (!strcasecmp(cmd, me.join_chan)) {
				sts(":%s JOIN %s", SplitServ.nick, 
                                    me.join_chan);
			}
		} else if (!strcasecmp(cmd, "PING")) {
			char * cmd = strtok(NULL, " ");
			char * p = strtok(NULL, " ");
			p++;
			sts(":%s PONG %s :%s", me.name, p, cmd);
		} else if (!strcasecmp(cmd, "PRIVMSG")) {
			char * target = strtok(NULL, " ");
			char * cmd = strtok(NULL, " ");
			char * p = strtok(NULL, " ");
			char * q = strtok(NULL, "\n");
			cmd++;
			if ((target[0] == '#')
#ifdef IRCD_DAL
			    || (target[0] == '+')
#endif /* IRCD_DAL */
) {
				if (!strcasecmp(cmd, "!split")) {
					PrintSplit(target);
				} else if (!strcasecmp(cmd, "!map")) {
					PrintMap(target, map_head, 0);
				} else if (!strcasecmp(cmd, "!dump")) {
					PrintDump(target);
				} else if (!strcasecmp(cmd, "!help")) {
					msg_list(target, help_pub);
                                } else if (!strcasecmp(cmd, "\001PING")) {
                                        CTCPClean(p);
                                        sts(":%s NOTICE %s :\001PING %s\001",
                                        	SplitServ.nick, origin, p);
                                } else if (!strcasecmp(cmd, "\001VERSION\001")) {
                                        sts(":%s NOTICE %s :\001VERSION %s\001",
                                            	SplitServ.nick, origin, 
						me.version);
                                }
			} else {
					
				if (!strcasecmp(cmd, "!split")) {
					PrintSplit(origin);
				} else if (!strcasecmp(cmd, "split")) {
					PrintSplit(origin);
				} else if (!strcasecmp(cmd, "!map")) {
					PrintMap(origin, map_head, 0);
				} else if (!strcasecmp(cmd, "map")) {
					PrintMap(origin, map_head, 0);
				} else if (!strcasecmp(cmd, "dump")) {
					PrintDump(origin);
				} else if (!strcasecmp(cmd, "!dump")) {
					PrintDump(origin);
				} else if (!strcasecmp(cmd, "die")) {
					Shutdown(origin, p, q);
				} else if (!strcasecmp(cmd, "restart")) {
					Restart(origin, p, q);
				} else if (!strcasecmp(cmd, "shutdown")) {
					Shutdown(origin, p, q);
				} else if (!strcasecmp(cmd, "!help")) {
					PrintHelp(origin, p);
				} else if (!strcasecmp(cmd, "help")) {
					PrintHelp(origin, p);
				} else if (!strcasecmp(cmd, "forget")) {
					Forget(origin, q, p);
				} else if (!strcasecmp(cmd, "add")) {
					Add(origin, q, p);
				} else if (!strcasecmp(cmd, "\001PING")) {
					CTCPClean(p);
					sts(":%s NOTICE %s :\001PING %s\001",
					     SplitServ.nick, origin, p);
				} else if (!strcasecmp(cmd, "\001VERSION\001")) {
					sts(":%s NOTICE %s :\001VERSION %s\001",
					     SplitServ.nick, origin, me.version);
				}
			}
		}
	} else {
		if (!strcasecmp(origin, "PING")) {
                        sts("PONG %s", cmd);
		} else if (!strcasecmp(origin, "PASS")) {
			InitSplitServ();
		} else if (!strcasecmp(origin, "SERVER")) {
			char *c = strdup(cmd);
			if (!is_delayed) {
				log("New Server: %s", c);
				privmsg(me.join_chan, "CONNECT: %s to %s",
					c, me.name);
			}
			NewServer(c, me.name);
			DelSplit(c);
		} else if (!strcasecmp(origin, "SQUIT")) {
			char * serv = cmd;
			char * s = strdup(serv);
#ifdef IRCD_HYB6
			Server * sv;
			char * b2;
			int i;
#endif /* IRCD_HYB6 */
			cmd = strtok(NULL, "\n");
			cmd++;
#ifdef IRCD_HYB6
			log("Split: %s", s);
			if (!is_delayed) {
				privmsg(me.join_chan, "SPLIT: %s", serv);
			}
#else /* IRCD_HYB6 */
			log("Split: %s - %s", s, cmd);
			if (!is_delayed) {
				privmsg(me.join_chan, "SPLIT: %s - %s",
					serv, cmd);
			}
#endif /* IRCD_HYB6 */
#ifdef IRCD_HYB6
			sv = FindServer(s);
			if (sv) {
				for (i=0; i<MAXSERVER; i++) {
					if (sv->leaflist[i]) {
						b2=malloc(BUFSIZE);
						sprintf(b2, "SQUIT %s :QS",
						  sv->leaflist[i]->name);
						Parse(b2);
					}
				}
			}
#endif /* IRCD_HYB6 */
			DelServer(s);
			NewSplit(s);
		}
	}

	free(coreLine);
}

void PrintSplit(char* target)
{
	int i;
	int count = 0;
	char * td;
	struct timeval tv;
	time_t now = time(NULL);

	/* Everything in the Split List will have been created with
	   NewSplit, so it will have a valid time stamp */

	for (i=0; i<MAXSERVER; i++) {
		if (split_table[i]) {
			td = timediff(now - split_table[i]->ts);
			count++;
			privmsg(target, "SPLIT SERVER: %s for %s",
				split_table[i]->name, td);
			free(td);
                	tv.tv_usec = 750000; /* 3/4 a second delay */
                	tv.tv_sec = 0;       /* ignore this */
                	select(1, NULL, NULL, NULL, &tv);
		}
	}
	if (!count) {
		privmsg(target, "NO SPLITS");
	}
}

void PrintMap(char* target, Server* s, int level)
{
	int i;
	struct timeval tv;
	char* d = dash(level);
	if (s) {
		privmsg(target, "%s %s", d, s->name);
		tv.tv_usec = 750000; /* 3/4 a second delay */
		tv.tv_sec = 0;       /* ignore this */
		select(1, NULL, NULL, NULL, &tv);
		for (i=0; i<MAXSERVER; i++) {
			if (s->leaflist[i]) {
				if (s->leaflist[i]->name) {
					PrintMap(target, s->leaflist[i],
						level+1);
				}
			}
		}
	}
	free(d);
}

char* dash(int level)
{
	int i;
	char* s = malloc(MAXDEPTH*3);
	s[0] = '\0';
	if (!level) {
		return s;
	}
	s[0] = ' ';
	s[1] = '\0';
	for (i=level - 1; i>=0; i--) {
		if (!i) {
			sprintf(s, "%s`-", s);
		} else {
			sprintf(s, "%s    ", s);
		}
	}
	return s;
}

void PrintDump(char * target)
{
	int i,j;
	char leaves[BUFSIZE] = "";
	struct timeval tv;
	for (i=0; i<MAXSERVER; i++) {
		leaves[0] = '\0';
		if (server_table[i]) {
			for (j=0; j<MAXSERVER; j++) {
				if (server_table[i]->leaflist[j]) {
					sprintf(leaves, "%s %s", leaves,
					  server_table[i]->leaflist[j]->name);
				}
			}
			privmsg(target, "Server: %s Leaves:%s",
				server_table[i]->name,
				(!strcmp(leaves, "")) ? " None" : leaves);
                        tv.tv_usec = 750000; /* 3/4 a second delay */
                        tv.tv_sec = 0;       /* ignore this */
                        select(1, NULL, NULL, NULL, &tv);
		}
	}
}

void Shutdown(char* target, char* pass, char* reason)
{
    if (pass) {
	if (!strcmp(pass, me.adpass)) {
#ifdef IRCD_HYBRID
		sts(":%s WALLOPS :Shutdown by %s: %s", me.name, target,
		    (reason) ? reason : "No Reason");
#endif
#ifdef IRCD_HYB6
		sts(":%s WALLOPS :Shutdown by %s: %s", me.name, target,
		    (reason) ? reason : "No Reason");
#endif
#ifdef IRCD_DAL
		sts(":%s GLOBOPS :Shutdown by %s: %s", me.name, target,
		    (reason) ? reason : "No Reason");
#endif
		sts(":%s QUIT :Shutdown by %s: %s", SplitServ.nick, target,
		    (reason) ? reason : "No Reason");
		log("Shutdown by %s: %s", target, 
		    (reason) ? reason : "No Reason");
		sleep(1);
		close(servsock);
		exit(0);
	}
    }
    privmsg(target, "Incorrect Password");
}

void Restart(char * target, char * pass, char * reason)
{
    if (pass) {
	if (!strcmp(pass, me.adpass)) {
#ifdef IRCD_HYBRID
                sts(":%s WALLOPS :Restart by %s: %s", me.name, target,
		    (reason) ? reason : "No Reason");
#endif
#ifdef IRCD_HYB6
		sts(":%s WALLOPS :Restart by %s: %s", me.name, target,
		    (reason) ? reason : "No Reason");
#endif
#ifdef IRCD_DAL
                sts(":%s GLOBOPS :Restart by %s: %s", me.name, target,
		    (reason) ? reason : "No Reason");
#endif
                sts(":%s QUIT :Restart by %s: %s", SplitServ.nick, target,
		    (reason) ? reason : "No Reason");
		log("Restart by %s: %s", target,
		    (reason) ? reason : "No Reason");
		sleep(1);
                close(servsock);
		execv(SPATH, NULL);
	}
    }
    privmsg(target, "Incorrect Password");
}

void Add(char * origin, char * pass, char * serv)
{
	Server * s = NULL;

	if (pass) {
	   if (!strcmp(pass, me.adpass)) {
		s = FindServer(serv);
		if (s) {
		   privmsg(origin, "Can't add a split for an existing server");
		   return;
		}
		s = FindSplit(serv);
		if (s) {
		   privmsg(origin, "Can't add a split for an existing split");
		   return;
		}
		NewSplit(strdup(serv));
		privmsg(me.join_chan, "ADDED SPLIT:  %s", serv);
                log("Added split %s by %s", serv, origin);
		return;
	   }
	}

	privmsg(origin, "Incorrect Password");
}

void Forget(char * origin, char * pass, char * serv)
{
	int i;
	Server * s = NULL;

	if (pass) {
	    if (!strcmp(pass, me.adpass)) {
		for (i=0; i<MAXSERVER; i++) {
		    if (split_table[i]) {
			if (!strcasecmp(split_table[i]->name, serv)) {
			    privmsg(origin, "%s Removed from the Split Table",
				split_table[i]->name);
			    s = split_table[i];
			    split_table[i] = NULL;
			    privmsg(me.join_chan, "FORGOT SPLIT: %s",
				s->name);
			    log("Forgot split %s by %s", s->name, origin);
			    free(s);
			    return;
			}
		    }
		}

		privmsg(origin, "%s NOT found in the Split Table", serv);
		return;
	    }
	}

	privmsg(origin, "Incorrect Password");
}

void PrintHelp(char * target, char * cmd)
{
	if (cmd) {
		if (!strcasecmp(cmd, "!map")) {
			msg_list(target, help_map);
		} else if (!strcasecmp(cmd, "map")) {
			msg_list(target, help_map);
		} else if (!strcasecmp(cmd, "!split")) {
			msg_list(target, help_split);
		} else if (!strcasecmp(cmd, "split")) {
			msg_list(target, help_split);
		} else if (!strcasecmp(cmd, "!dump")) {
			msg_list(target, help_dump);
		} else if (!strcasecmp(cmd, "dump")) {
			msg_list(target, help_dump);
		} else if (!strcasecmp(cmd, "shutdown")) {
			msg_list(target, help_shutdown);
		} else if (!strcasecmp(cmd, "die")) {
			msg_list(target, help_shutdown);
		} else if (!strcasecmp(cmd, "restart")) {
			msg_list(target, help_restart);
		} else if (!strcasecmp(cmd, "forget")) {
			msg_list(target, help_forget);
		} else if (!strcasecmp(cmd, "add")) {
			msg_list(target, help_add);
		}
	} else {
		msg_list(target, help_main);
	}
}
