/**************************************************************
* SplitServ main header file
* $Id: split.h,v 1.37 2000/12/15 03:52:59 wcampbel Exp $
**************************************************************/

#ifndef SPLIT_H
#define SPLIT_H

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
/* #include <errno.h> */
#include <netdb.h>
#include <netinet/in.h>
#include <unistd.h>
#include <time.h>
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include <sys/time.h>
#include <ctype.h>
#include <sys/stat.h>
#include "config.h"

#define BUFSIZE 512
#define MAXSERVER 64
#define bzero(x,y)	memset(x, '\0', y);
#define MAXNICK	32
#define MAXUSER	10
#define MAXHOST	63
#define MAXPASS	32
#define MAXDEPTH 15
#define LINE 80
#define TRUE 1
#define FALSE 0

typedef struct server_ Server;

struct server_ {
	char* name;
	Server* uplink;
	int numleaf;
	time_t ts;
	Server* leaflist[MAXSERVER];
};

struct me {
	char uplink[MAXHOST];
	char name[MAXHOST];
	int port;
	char desc[LINE];
	int r_time;
	char pass[MAXPASS];
	char adpass[MAXPASS];
	char version[LINE];
	int privmsg : 1;
	int chanmsg : 1;
	int numserver;
	char join_chan[LINE];
	int delay;
} me;

struct SplitServ {
	char host[MAXHOST];
	char user[MAXUSER];
	char nick[MAXNICK];
} SplitServ;

int servsock;
time_t notice;
int is_delayed;
Server* split_table[MAXSERVER];
Server* server_table[MAXSERVER];
Server* map_head;

/* conf.c */
extern void InitDefaults();
extern void strip(char *);
extern void LoadConf();

/* sock.c */
extern void ListenLoop();
extern int Connect();

/* irc.c */
extern void Register();
extern void InitSplitServ();
extern void Parse(char *);
extern void PrintSplit(char *);
extern void PrintMap(char *, Server *, int);
extern void PrintDump(char *);
extern char* dash(int);
extern void Shutdown(char *, char *, char *);
extern void Restart(char *, char *, char *);
extern void Add(char *, char *, char *);
extern void Forget(char *, char *, char *);
extern void PrintHelp(char *, char *);

/* util.c */
extern void log(char *, ...);
extern void sts(char *, ...);
extern void msg_list(char *, const char **);
extern char *timediff(time_t);
extern void CTCPClean(char *);
extern void chk();
extern void privmsg(char *, char *, ...);
int is_channel(char *);

/* data.c */
extern void InitTables();
extern Server* NewServer(char *, char *);
extern Server* FindServer(char *);
extern void DelServer(char *);
extern void NewSplit(char *);
extern void DelSplit(char *);
extern Server* FindSplit(char *);

/* help.c */
extern const char *help_main[];
extern const char *help_pub[];
extern const char *help_map[];
extern const char *help_split[];
extern const char *help_dump[];
extern const char *help_shutdown[];
extern const char *help_restart[];
extern const char *help_forget[];
extern const char *help_add[];

#endif
