/*********************************************
* util.c - Utility functions
*
* CVS $Id: util.c,v 1.15 2000/12/15 03:35:39 wcampbel Exp $
*********************************************/

#include "split.h"

void log(char *fmt, ...)
{
        va_list ap;
        FILE *logfile;
        char buf[512], fmtime[80];
        time_t tmp = time(NULL);

        va_start(ap, fmt);
        vsnprintf(buf, 512, fmt, ap);

        strftime(fmtime, 80, "%H:%M[%m/%d/%Y]", localtime(&tmp));

        if ((logfile = fopen(LOGFILE, "a")) == NULL) return;

        if (logfile)
                fprintf(logfile, "(%s) %s\n", fmtime, buf);

#ifdef DEBUG
        fprintf(stderr, "(%s) %s\n", fmtime, buf);
#endif

        fclose(logfile);
        va_end(ap);
}

void sts(char *fmt,...)
{
        va_list ap;
        char buf[512];

        va_start (ap, fmt);
        vsnprintf (buf, 512, fmt, ap);

#ifdef DEBUG
        log("SENT: %s", buf);
#endif
        strcat (buf, "\n");

        if ((write (servsock, buf, strlen (buf))) == -1) {
                log("Write error.");
                exit(0);
        }

        va_end (ap);
}

void msg_list(char *to, const char **text)
{
        while (*text) {
                if (**text)
			privmsg(to, "%s", *text);
                else
			privmsg(to, " ", *text);
                text++;
        }
}

char *timediff(time_t u)
{
	char* buf = malloc(LINE);

        if (u > 86400)
                sprintf(buf, "%ld day%s, %02ld:%02ld",
                        u/86400, (u/86400 == 1) ? "" : "s",
                        (u/3600) % 24, (u/60) % 60);
        else if (u > 3600)
                sprintf(buf, "%ld hour%s, %ld minute%s",
                        u/3600, u/3600==1 ? "" : "s",
                        (u/60) % 60, (u/60)%60 == 1 ? "" : "s");
        else
                sprintf(buf, "%ld minute%s, %ld second%s",
                        u/60, u/60 == 1 ? "" : "s",
                        u%60, u%60 == 1 ? "" : "s");

        return buf;
}

void CTCPClean(char *line)
{
        char *c;   
        
        if ((c = strchr(line, '\001')))   *c = '\0';
}

void chk()
{
        time_t current = time(NULL);

        if (current > notice) {
                is_delayed = 0;
        } else {
                /* rien */
        }

}

/* Send a message to a user from a user */
void privmsg(char *to, char *fmt, ...)
{
        va_list ap;
        char buf[512], buf2[512];

        va_start(ap, fmt);
        vsnprintf(buf2, sizeof(buf2), fmt, ap);
	if (is_channel(to)) {
	    if (me.chanmsg)
		sprintf(buf, ":%s PRIVMSG %s :%s", SplitServ.nick, to, buf2);
	    else
		sprintf(buf, ":%s NOTICE %s :%s", SplitServ.nick, to, buf2);
	}
	else {
            if (me.privmsg)
                sprintf(buf, ":%s PRIVMSG %s :%s", SplitServ.nick, to, buf2);
            else
                sprintf(buf, ":%s NOTICE %s :%s", SplitServ.nick, to, buf2);
	}
        sts("%s", buf);
        va_end(ap);
}

int is_channel(char *chan)
{
	if (chan) {
		if ( (chan[0] == '#') || (chan[0] == '+') )
			return TRUE;
		return FALSE;
	}

	/* Shouldn't get here */
	return FALSE;
}
